#ifndef accel_h
#define accel_h

#include <complex.h>
using namespace std;

//series acceleration
namespace accel
{
  inline complex <double> levin(complex <double> g1, complex <double> g2)
  {
    return g2*g2/g1;
  }
  inline complex <double> levin(complex <double> g1, complex <double> g2, complex <double> g3)
  {
    complex <double> b = 1./(1.-1./2.*g3*g1/(g2*g2)) - 2.;
    return 3.*g3/(g1*g2)*( 2.* ((5.+2.*b)*g2*g2-(3.+b)*g1*g3) / (12.+7.*b+b*b) + g1*g3 - g2*g2);    
  }
  inline complex <double> weninger(complex <double> g1, complex <double> g2, complex <double> g3)
  {
    return g3/(3.*g1*g2)*(4.*g1*g3-g2*g2);
  }


  inline double levin(double g1, double g2)
  {
    return g2*g2/g1;
  }
  inline double levin(double g1, double g2, double g3)
  {
    double b = 1./(1.-1./2.*g3*g1/(g2*g2)) - 2.;
    return 3.*g3/(g1*g2)*( 2.* ((5.+2.*b)*g2*g2-(3.+b)*g1*g3) / (12.+7.*b+b*b) + g1*g3 - g2*g2);    
  }
  inline double levinbeta0(double g1, double g2, double g3)
  {
    double b = 0.;
    return 3.*g3/(g1*g2)*( 2.* ((5.+2.*b)*g2*g2-(3.+b)*g1*g3) / (12.+7.*b+b*b) + g1*g3 - g2*g2);    
  }
  inline double weninger(double g1, double g2, double g3)
  {
    return g3/(3.*g1*g2)*(4.*g1*g3-g2*g2);
  }
}

#endif
