#include "muf.h"
#include "resint.h"
#include "pmom.h"
#include "mesq.h"
#include "settings.h"
#include "ccoeff.h"
#include "resconst.h"

using namespace pmom;
using namespace resconst;
using namespace ccoeff;

complex <double> muf::h4st_qqb_qg   (int idx) {return +2.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+2.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-4.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+2.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LF2+2.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ2-4.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ*LF+2.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LF2+2.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ2-4.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ*LF+C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+3.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-3.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2+2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LF3-2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ3+6.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ2*LF-6.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ*LF2+2.*C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LF-2.*C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ+2.*C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LF-2.*C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LQ+2.*C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LF-2.*C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF2+C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2-2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+3.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+3.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-6.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+beta1*C1qg[idx]*gamma1gq[idx]*LF2-3.*beta1*C1qg[idx]*gamma1gq[idx]*LQ2+2.*beta1*C1qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C2qg[idx]*gamma1gq[idx]*LF2-5.*beta0*C2qg[idx]*gamma1gq[idx]*LQ2+4.*beta0*C2qg[idx]*gamma1gq[idx]*LQ*LF+2.*beta0*C1qg[idx]*gamma2gq[idx]*LF2-4.*beta0*C1qg[idx]*gamma2gq[idx]*LQ2+2.*beta0*C1qg[idx]*gamma2gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3+2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3-3.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF+3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF3+6.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3-9.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF+beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LF2-5.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2+4.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+2./3.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LF3-11./3.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ3+2.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ*LF2+2.*B2*C1qg[idx]*gamma1gq[idx]*LQ2-2.*B2*C1qg[idx]*gamma1gq[idx]*LQ*LF+2.*B1*C2qg[idx]*gamma1gq[idx]*LQ2-2.*B1*C2qg[idx]*gamma1gq[idx]*LQ*LF+2.*B1*C1qg[idx]*gamma2gq[idx]*LQ2-2.*B1*C1qg[idx]*gamma2gq[idx]*LQ*LF-B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-3.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3+6.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF-3.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF2+2.*B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2-2.*B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+4.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3-3.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF-B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ*LF2-pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ3+pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+A2*C1qg[idx]*gamma1gq[idx]*LQ3-A2*C1qg[idx]*gamma1gq[idx]*LQ2*LF+A1*C2qg[idx]*gamma1gq[idx]*LQ3-A1*C2qg[idx]*gamma1gq[idx]*LQ2*LF+A1*C1qg[idx]*gamma2gq[idx]*LQ3-A1*C1qg[idx]*gamma2gq[idx]*LQ2*LF-1./2.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ4+A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF-1./2.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2-3./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ4+3.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3*LF-3./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF2+A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ3-A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2*LF+13./6.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ4-5./3.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./2.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF2-A1*B1*C1qg[idx]*gamma1gq[idx]*LQ4+A1*B1*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./4.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ5+1./4.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ4*LF;}
complex <double> muf::h4st_qg_qg    (int idx) {return +C3qg[idx]*gamma1qq[idx]*LF-C3qg[idx]*gamma1qq[idx]*LQ+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+C2qg[idx]*gamma2qq[idx]*LF-C2qg[idx]*gamma2qq[idx]*LQ+C2qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LF2+C2qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ2-2.*C2qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ*LF+1./2.*C2qg[idx]*pow(gamma1qq[idx],2)*LF2+1./2.*C2qg[idx]*pow(gamma1qq[idx],2)*LQ2-C2qg[idx]*pow(gamma1qq[idx],2)*LQ*LF+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2-3.*C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2-3.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2+C1qg[idx]*gamma3qq[idx]*LF-C1qg[idx]*gamma3qq[idx]*LQ+C1qg[idx]*gamma2qq[idx]*gamma1gg[idx]*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gg[idx]*LQ2-2.*C1qg[idx]*gamma2qq[idx]*gamma1gg[idx]*LQ*LF+C1qg[idx]*gamma1qq[idx]*gamma2gg[idx]*LF2+C1qg[idx]*gamma1qq[idx]*gamma2gg[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2gg[idx]*LQ*LF+1./2.*C1qg[idx]*gamma1qq[idx]*pow(gamma1gg[idx],2)*LF3-1./2.*C1qg[idx]*gamma1qq[idx]*pow(gamma1gg[idx],2)*LQ3+3./2.*C1qg[idx]*gamma1qq[idx]*pow(gamma1gg[idx],2)*LQ2*LF-3./2.*C1qg[idx]*gamma1qq[idx]*pow(gamma1gg[idx],2)*LQ*LF2+4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3-4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+C1qg[idx]*gamma1qq[idx]*gamma2qq[idx]*LF2+C1qg[idx]*gamma1qq[idx]*gamma2qq[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2qq[idx]*LQ*LF+1./2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gg[idx]*LF3-1./2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gg[idx]*LQ3+3./2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gg[idx]*LQ2*LF-3./2.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gg[idx]*LQ*LF2+1./6.*C1qg[idx]*pow(gamma1qq[idx],3)*LF3-1./6.*C1qg[idx]*pow(gamma1qq[idx],3)*LQ3+1./2.*C1qg[idx]*pow(gamma1qq[idx],3)*LQ2*LF-1./2.*C1qg[idx]*pow(gamma1qq[idx],3)*LQ*LF2+C2qq[idx]*C1qg[idx]*gamma1gg[idx]*LF-C2qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ+C2qq[idx]*C1qg[idx]*gamma1qq[idx]*LF-C2qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ+C1qq[idx]*C2qg[idx]*gamma1gg[idx]*LF-C1qq[idx]*C2qg[idx]*gamma1gg[idx]*LQ+C1qq[idx]*C2qg[idx]*gamma1qq[idx]*LF-C1qq[idx]*C2qg[idx]*gamma1qq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma2gg[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2gg[idx]*LQ+1./2.*C1qq[idx]*C1qg[idx]*pow(gamma1gg[idx],2)*LF2+1./2.*C1qq[idx]*C1qg[idx]*pow(gamma1gg[idx],2)*LQ2-C1qq[idx]*C1qg[idx]*pow(gamma1gg[idx],2)*LQ*LF+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+C1qq[idx]*C1qg[idx]*gamma2qq[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2qq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LF2+C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ2-2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ*LF+1./2.*C1qq[idx]*C1qg[idx]*pow(gamma1qq[idx],2)*LF2+1./2.*C1qq[idx]*C1qg[idx]*pow(gamma1qq[idx],2)*LQ2-C1qq[idx]*C1qg[idx]*pow(gamma1qq[idx],2)*LQ*LF+double(NF)*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3-double(NF)*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+3.*double(NF)*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-3.*double(NF)*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+double(NF)*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+double(NF)*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-2.*double(NF)*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta1*C1qg[idx]*gamma1gg[idx]*LF2-3./2.*beta1*C1qg[idx]*gamma1gg[idx]*LQ2+beta1*C1qg[idx]*gamma1gg[idx]*LQ*LF+1./2.*beta1*C1qg[idx]*gamma1qq[idx]*LF2-3./2.*beta1*C1qg[idx]*gamma1qq[idx]*LQ2+beta1*C1qg[idx]*gamma1qq[idx]*LQ*LF+1./2.*beta0*C2qg[idx]*gamma1gg[idx]*LF2-5./2.*beta0*C2qg[idx]*gamma1gg[idx]*LQ2+2.*beta0*C2qg[idx]*gamma1gg[idx]*LQ*LF+1./2.*beta0*C2qg[idx]*gamma1qq[idx]*LF2-5./2.*beta0*C2qg[idx]*gamma1qq[idx]*LQ2+2.*beta0*C2qg[idx]*gamma1qq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2gg[idx]*LF2-2.*beta0*C1qg[idx]*gamma2gg[idx]*LQ2+beta0*C1qg[idx]*gamma2gg[idx]*LQ*LF+1./2.*beta0*C1qg[idx]*pow(gamma1gg[idx],2)*LF3+beta0*C1qg[idx]*pow(gamma1gg[idx],2)*LQ3-3./2.*beta0*C1qg[idx]*pow(gamma1gg[idx],2)*LQ2*LF+3./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+beta0*C1qg[idx]*gamma2qq[idx]*LF2-2.*beta0*C1qg[idx]*gamma2qq[idx]*LQ2+beta0*C1qg[idx]*gamma2qq[idx]*LQ*LF+beta0*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LF3+2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ3-3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ2*LF+1./2.*beta0*C1qg[idx]*pow(gamma1qq[idx],2)*LF3+beta0*C1qg[idx]*pow(gamma1qq[idx],2)*LQ3-3./2.*beta0*C1qg[idx]*pow(gamma1qq[idx],2)*LQ2*LF+1./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LF2-5./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ2+2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ*LF+1./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LF2-5./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ2+2.*beta0*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ*LF+beta0*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+2.*beta0*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3-3.*beta0*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+1./3.*pow(beta0,2)*C1qg[idx]*gamma1gg[idx]*LF3-11./6.*pow(beta0,2)*C1qg[idx]*gamma1gg[idx]*LQ3+pow(beta0,2)*C1qg[idx]*gamma1gg[idx]*LQ2*LF+1./2.*pow(beta0,2)*C1qg[idx]*gamma1gg[idx]*LQ*LF2+1./3.*pow(beta0,2)*C1qg[idx]*gamma1qq[idx]*LF3-11./6.*pow(beta0,2)*C1qg[idx]*gamma1qq[idx]*LQ3+pow(beta0,2)*C1qg[idx]*gamma1qq[idx]*LQ2*LF+1./2.*pow(beta0,2)*C1qg[idx]*gamma1qq[idx]*LQ*LF2+B2*C1qg[idx]*gamma1gg[idx]*LQ2-B2*C1qg[idx]*gamma1gg[idx]*LQ*LF+B2*C1qg[idx]*gamma1qq[idx]*LQ2-B2*C1qg[idx]*gamma1qq[idx]*LQ*LF+B1*C2qg[idx]*gamma1gg[idx]*LQ2-B1*C2qg[idx]*gamma1gg[idx]*LQ*LF+B1*C2qg[idx]*gamma1qq[idx]*LQ2-B1*C2qg[idx]*gamma1qq[idx]*LQ*LF+B1*C1qg[idx]*gamma2gg[idx]*LQ2-B1*C1qg[idx]*gamma2gg[idx]*LQ*LF-1./2.*B1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ3+B1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ2*LF-1./2.*B1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ*LF2-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+B1*C1qg[idx]*gamma2qq[idx]*LQ2-B1*C1qg[idx]*gamma2qq[idx]*LQ*LF-B1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ3+2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ2*LF-B1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ*LF2-1./2.*B1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ3+B1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ2*LF-1./2.*B1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ*LF2+B1*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ2-B1*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ*LF+B1*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ2-B1*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ*LF-B1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+2.*B1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-B1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+2.*B1*beta0*C1qg[idx]*gamma1gg[idx]*LQ3-3./2.*B1*beta0*C1qg[idx]*gamma1gg[idx]*LQ2*LF-1./2.*B1*beta0*C1qg[idx]*gamma1gg[idx]*LQ*LF2+2.*B1*beta0*C1qg[idx]*gamma1qq[idx]*LQ3-3./2.*B1*beta0*C1qg[idx]*gamma1qq[idx]*LQ2*LF-1./2.*B1*beta0*C1qg[idx]*gamma1qq[idx]*LQ*LF2-1./2.*pow(B1,2)*C1qg[idx]*gamma1gg[idx]*LQ3+1./2.*pow(B1,2)*C1qg[idx]*gamma1gg[idx]*LQ2*LF-1./2.*pow(B1,2)*C1qg[idx]*gamma1qq[idx]*LQ3+1./2.*pow(B1,2)*C1qg[idx]*gamma1qq[idx]*LQ2*LF+1./2.*A2*C1qg[idx]*gamma1gg[idx]*LQ3-1./2.*A2*C1qg[idx]*gamma1gg[idx]*LQ2*LF+1./2.*A2*C1qg[idx]*gamma1qq[idx]*LQ3-1./2.*A2*C1qg[idx]*gamma1qq[idx]*LQ2*LF+1./2.*A1*C2qg[idx]*gamma1gg[idx]*LQ3-1./2.*A1*C2qg[idx]*gamma1gg[idx]*LQ2*LF+1./2.*A1*C2qg[idx]*gamma1qq[idx]*LQ3-1./2.*A1*C2qg[idx]*gamma1qq[idx]*LQ2*LF+1./2.*A1*C1qg[idx]*gamma2gg[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2gg[idx]*LQ2*LF-1./4.*A1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ4+1./2.*A1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ3*LF-1./4.*A1*C1qg[idx]*pow(gamma1gg[idx],2)*LQ2*LF2-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2+1./2.*A1*C1qg[idx]*gamma2qq[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2qq[idx]*LQ2*LF-1./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ4+A1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ3*LF-1./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gg[idx]*LQ2*LF2-1./4.*A1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ4+1./2.*A1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ3*LF-1./4.*A1*C1qg[idx]*pow(gamma1qq[idx],2)*LQ2*LF2+1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ3-1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gg[idx]*LQ2*LF+1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ3-1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*LQ2*LF-1./2.*A1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+A1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF-1./2.*A1*double(NF)*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2+13./12.*A1*beta0*C1qg[idx]*gamma1gg[idx]*LQ4-5./6.*A1*beta0*C1qg[idx]*gamma1gg[idx]*LQ3*LF-1./4.*A1*beta0*C1qg[idx]*gamma1gg[idx]*LQ2*LF2+13./12.*A1*beta0*C1qg[idx]*gamma1qq[idx]*LQ4-5./6.*A1*beta0*C1qg[idx]*gamma1qq[idx]*LQ3*LF-1./4.*A1*beta0*C1qg[idx]*gamma1qq[idx]*LQ2*LF2-1./2.*A1*B1*C1qg[idx]*gamma1gg[idx]*LQ4+1./2.*A1*B1*C1qg[idx]*gamma1gg[idx]*LQ3*LF-1./2.*A1*B1*C1qg[idx]*gamma1qq[idx]*LQ4+1./2.*A1*B1*C1qg[idx]*gamma1qq[idx]*LQ3*LF-1./8.*pow(A1,2)*C1qg[idx]*gamma1gg[idx]*LQ5+1./8.*pow(A1,2)*C1qg[idx]*gamma1gg[idx]*LQ4*LF-1./8.*pow(A1,2)*C1qg[idx]*gamma1qq[idx]*LQ5+1./8.*pow(A1,2)*C1qg[idx]*gamma1qq[idx]*LQ4*LF;}
complex <double> muf::h4st_qq_qg    (int idx) {return +C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-2.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ2-2.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LF2+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ*LF+1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2+C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LF3-C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ3+3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ2*LF-3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ*LF2+C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LF-C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LF-C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LQ+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF2+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2-C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta1*C1qg[idx]*gamma1gq[idx]*LF2-3./2.*beta1*C1qg[idx]*gamma1gq[idx]*LQ2+beta1*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta0*C2qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2gq[idx]*LF2-2.*beta0*C1qg[idx]*gamma2gq[idx]*LQ2+beta0*C1qg[idx]*gamma2gq[idx]*LQ*LF+1./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3+beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3-3./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF+3./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF+1./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./3.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LF3-11./6.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ3+pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ*LF2+B2*C1qg[idx]*gamma1gq[idx]*LQ2-B2*C1qg[idx]*gamma1gq[idx]*LQ*LF+B1*C2qg[idx]*gamma1gq[idx]*LQ2-B1*C2qg[idx]*gamma1gq[idx]*LQ*LF+B1*C1qg[idx]*gamma2gq[idx]*LQ2-B1*C1qg[idx]*gamma2gq[idx]*LQ*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF2+B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2-B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3-3./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF-1./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ*LF2-1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ3+1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ2*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ4+1./2.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF2+1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2*LF+13./12.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ4-5./6.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./4.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF2-1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ4+1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ5+1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ4*LF;}
complex <double> muf::h4st_qqp_qg   (int idx) {return +C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-2.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ2-2.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LF2+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ*LF+1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2+C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LF3-C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ3+3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ2*LF-3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ*LF2+C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LF-C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LF-C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LQ+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF2+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2-C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta1*C1qg[idx]*gamma1gq[idx]*LF2-3./2.*beta1*C1qg[idx]*gamma1gq[idx]*LQ2+beta1*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta0*C2qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2gq[idx]*LF2-2.*beta0*C1qg[idx]*gamma2gq[idx]*LQ2+beta0*C1qg[idx]*gamma2gq[idx]*LQ*LF+1./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3+beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3-3./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF+3./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF+1./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./3.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LF3-11./6.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ3+pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ*LF2+B2*C1qg[idx]*gamma1gq[idx]*LQ2-B2*C1qg[idx]*gamma1gq[idx]*LQ*LF+B1*C2qg[idx]*gamma1gq[idx]*LQ2-B1*C2qg[idx]*gamma1gq[idx]*LQ*LF+B1*C1qg[idx]*gamma2gq[idx]*LQ2-B1*C1qg[idx]*gamma2gq[idx]*LQ*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF2+B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2-B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3-3./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF-1./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ*LF2-1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ3+1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ2*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ4+1./2.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF2+1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2*LF+13./12.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ4-5./6.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./4.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF2-1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ4+1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ5+1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ4*LF;}
complex <double> muf::h4st_qqbp_qg  (int idx) {return +C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-2.*C2qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ2-2.*C1qg[idx]*gamma2qq[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LF2+C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2gq[idx]*LQ*LF+1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-1./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-3./2.*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2+C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LF3-C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ3+3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ2*LF-3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1gq[idx]*LQ*LF2+C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LF-C2qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LF-C1qq[idx]*C2qg[idx]*gamma1gq[idx]*LQ+C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2gq[idx]*LQ+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF2+1./2.*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2-C1qq[idx]*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta1*C1qg[idx]*gamma1gq[idx]*LF2-3./2.*beta1*C1qg[idx]*gamma1gq[idx]*LQ2+beta1*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./2.*beta0*C2qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C2qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2gq[idx]*LF2-2.*beta0*C1qg[idx]*gamma2gq[idx]*LQ2+beta0*C1qg[idx]*gamma2gq[idx]*LQ*LF+1./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3+beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3-3./2.*beta0*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF+3./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF+1./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LF2-5./2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2+2.*beta0*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+1./3.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LF3-11./6.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ3+pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*pow(beta0,2)*C1qg[idx]*gamma1gq[idx]*LQ*LF2+B2*C1qg[idx]*gamma1gq[idx]*LQ2-B2*C1qg[idx]*gamma1gq[idx]*LQ*LF+B1*C2qg[idx]*gamma1gq[idx]*LQ2-B1*C2qg[idx]*gamma1gq[idx]*LQ*LF+B1*C1qg[idx]*gamma2gq[idx]*LQ2-B1*C1qg[idx]*gamma2gq[idx]*LQ*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-1./2.*B1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ*LF2+B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2-B1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ*LF+2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3-3./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF-1./2.*B1*beta0*C1qg[idx]*gamma1gq[idx]*LQ*LF2-1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ3+1./2.*pow(B1,2)*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A2*C1qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C2qg[idx]*gamma1gq[idx]*LQ2*LF+1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2gq[idx]*LQ2*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ4+1./2.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF-1./4.*A1*C1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qq[idx]*gamma1gq[idx]*LQ2*LF2+1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ3-1./2.*A1*C1qq[idx]*C1qg[idx]*gamma1gq[idx]*LQ2*LF+13./12.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ4-5./6.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./4.*A1*beta0*C1qg[idx]*gamma1gq[idx]*LQ2*LF2-1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ4+1./2.*A1*B1*C1qg[idx]*gamma1gq[idx]*LQ3*LF-1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ5+1./8.*pow(A1,2)*C1qg[idx]*gamma1gq[idx]*LQ4*LF;}
complex <double> muf::h4st_gg_qg    (int idx) {return +2.*C3qg[idx]*gamma1qg[idx]*LF-2.*C3qg[idx]*gamma1qg[idx]*LQ+2.*C2qg[idx]*gamma2qg[idx]*LF-2.*C2qg[idx]*gamma2qg[idx]*LQ+3.*C2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+3.*C2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2-6.*C2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+C2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+C2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2-2.*C2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+2.*C1qg[idx]*gamma3qg[idx]*LF-2.*C1qg[idx]*gamma3qg[idx]*LQ+2.*C1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LF2+2.*C1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ2-6.*C1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ*LF-2.*C1qg[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF-2.*C1qg[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF-2.*C1qg[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF+4.*C1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LF2+4.*C1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LQ2-6.*C1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LQ*LF+7./3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LF3-7./3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ3+7.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ2*LF-7.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ*LF2-2.*C1qg[idx]*gamma2qq[idx]*gamma1qg[idx]*LQ*LF+2.*C1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LF2+2.*C1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LQ2-2.*C1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LQ*LF+4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LF3-4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3+4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF-4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF2+1./3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LF3-1./3.*C1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ3+C1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ2*LF-C1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ*LF2+2.*C2qq[idx]*C1qg[idx]*gamma1qg[idx]*LF-2.*C2qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ+2.*C1qq[idx]*C2qg[idx]*gamma1qg[idx]*LF-2.*C1qq[idx]*C2qg[idx]*gamma1qg[idx]*LQ+2.*C1qq[idx]*C1qg[idx]*gamma2qg[idx]*LF-2.*C1qq[idx]*C1qg[idx]*gamma2qg[idx]*LQ+3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2-6.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2-2.*C1qq[idx]*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+8./3.*double(NF)*C1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF3-8./3.*double(NF)*C1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3+8.*double(NF)*C1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF-8.*double(NF)*C1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF2+beta1*C1qg[idx]*gamma1qg[idx]*LF2-3.*beta1*C1qg[idx]*gamma1qg[idx]*LQ2+2.*beta1*C1qg[idx]*gamma1qg[idx]*LQ*LF+beta0*C2qg[idx]*gamma1qg[idx]*LF2-5.*beta0*C2qg[idx]*gamma1qg[idx]*LQ2+4.*beta0*C2qg[idx]*gamma1qg[idx]*LQ*LF+2.*beta0*C1qg[idx]*gamma2qg[idx]*LF2-4.*beta0*C1qg[idx]*gamma2qg[idx]*LQ2+2.*beta0*C1qg[idx]*gamma2qg[idx]*LQ*LF+3.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF3+6.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3-9.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF+beta0*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF3+2.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3-3.*beta0*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF+beta0*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LF2-5.*beta0*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ2+4.*beta0*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ*LF+2./3.*pow(beta0,2)*C1qg[idx]*gamma1qg[idx]*LF3-11./3.*pow(beta0,2)*C1qg[idx]*gamma1qg[idx]*LQ3+2.*pow(beta0,2)*C1qg[idx]*gamma1qg[idx]*LQ2*LF+pow(beta0,2)*C1qg[idx]*gamma1qg[idx]*LQ*LF2+2.*B2*C1qg[idx]*gamma1qg[idx]*LQ2-2.*B2*C1qg[idx]*gamma1qg[idx]*LQ*LF+2.*B1*C2qg[idx]*gamma1qg[idx]*LQ2-2.*B1*C2qg[idx]*gamma1qg[idx]*LQ*LF+2.*B1*C1qg[idx]*gamma2qg[idx]*LQ2-2.*B1*C1qg[idx]*gamma2qg[idx]*LQ*LF-3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3+6.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF-3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF2-B1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3+2.*B1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF-B1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF2+2.*B1*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ2-2.*B1*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ*LF+4.*B1*beta0*C1qg[idx]*gamma1qg[idx]*LQ3-3.*B1*beta0*C1qg[idx]*gamma1qg[idx]*LQ2*LF-B1*beta0*C1qg[idx]*gamma1qg[idx]*LQ*LF2-pow(B1,2)*C1qg[idx]*gamma1qg[idx]*LQ3+pow(B1,2)*C1qg[idx]*gamma1qg[idx]*LQ2*LF+A2*C1qg[idx]*gamma1qg[idx]*LQ3-A2*C1qg[idx]*gamma1qg[idx]*LQ2*LF+A1*C2qg[idx]*gamma1qg[idx]*LQ3-A1*C2qg[idx]*gamma1qg[idx]*LQ2*LF+A1*C1qg[idx]*gamma2qg[idx]*LQ3-A1*C1qg[idx]*gamma2qg[idx]*LQ2*LF-3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ4+3.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3*LF-3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF2-1./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ4+A1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3*LF-1./2.*A1*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF2+A1*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ3-A1*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*LQ2*LF+13./6.*A1*beta0*C1qg[idx]*gamma1qg[idx]*LQ4-5./3.*A1*beta0*C1qg[idx]*gamma1qg[idx]*LQ3*LF-1./2.*A1*beta0*C1qg[idx]*gamma1qg[idx]*LQ2*LF2-A1*B1*C1qg[idx]*gamma1qg[idx]*LQ4+A1*B1*C1qg[idx]*gamma1qg[idx]*LQ3*LF-1./4.*pow(A1,2)*C1qg[idx]*gamma1qg[idx]*LQ5+1./4.*pow(A1,2)*C1qg[idx]*gamma1qg[idx]*LQ4*LF;}
complex <double> muf::h4st_qbg_qg   (int idx) {return +C2qg[idx]*gamma2qqb[idx]*LF-C2qg[idx]*gamma2qqb[idx]*LQ+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma3qqb[idx]*LF-C1qg[idx]*gamma3qqb[idx]*LQ+C1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LF2+C1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ2-2.*C1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ*LF+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2-3.*C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2-3.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-C1qg[idx]*gamma1qq[idx]*gamma2qqb[idx]*LQ*LF+4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3-4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+C1qq[idx]*C1qg[idx]*gamma2qqb[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2qqb[idx]*LQ+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2qqb[idx]*LF2-2.*beta0*C1qg[idx]*gamma2qqb[idx]*LQ2+beta0*C1qg[idx]*gamma2qqb[idx]*LQ*LF+3./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+B1*C1qg[idx]*gamma2qqb[idx]*LQ2-B1*C1qg[idx]*gamma2qqb[idx]*LQ*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+1./2.*A1*C1qg[idx]*gamma2qqb[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2qqb[idx]*LQ2*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2;}
complex <double> muf::h4st_qpg_qg   (int idx) {return +C2qg[idx]*gamma2qqp[idx]*LF-C2qg[idx]*gamma2qqp[idx]*LQ+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma3qqp[idx]*LF-C1qg[idx]*gamma3qqp[idx]*LQ+C1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LF2+C1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ2-2.*C1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ*LF+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2-3.*C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2-3.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-C1qg[idx]*gamma1qq[idx]*gamma2qqp[idx]*LQ*LF+4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3-4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+C1qq[idx]*C1qg[idx]*gamma2qqp[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2qqp[idx]*LQ+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2qqp[idx]*LF2-2.*beta0*C1qg[idx]*gamma2qqp[idx]*LQ2+beta0*C1qg[idx]*gamma2qqp[idx]*LQ*LF+3./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+B1*C1qg[idx]*gamma2qqp[idx]*LQ2-B1*C1qg[idx]*gamma2qqp[idx]*LQ*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+1./2.*A1*C1qg[idx]*gamma2qqp[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2qqp[idx]*LQ2*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2;}
complex <double> muf::h4st_qbpg_qg  (int idx) {return +C2qg[idx]*gamma2qqbp[idx]*LF-C2qg[idx]*gamma2qqbp[idx]*LQ+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+C1qg[idx]*gamma3qqbp[idx]*LF-C1qg[idx]*gamma3qqbp[idx]*LQ+C1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LF2+C1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ2-2.*C1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ*LF+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2+C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2-3.*C1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+2.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2-3.*C1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3-5./3.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF-5.*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2-C1qg[idx]*gamma1qq[idx]*gamma2qqbp[idx]*LQ*LF+4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3-4./3.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-4.*C1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+C1qq[idx]*C1qg[idx]*gamma2qqbp[idx]*LF-C1qq[idx]*C1qg[idx]*gamma2qqbp[idx]*LQ+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+3./2.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2-3.*C1qq[idx]*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+beta0*C1qg[idx]*gamma2qqbp[idx]*LF2-2.*beta0*C1qg[idx]*gamma2qqbp[idx]*LQ2+beta0*C1qg[idx]*gamma2qqbp[idx]*LQ*LF+3./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+3.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3-9./2.*beta0*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+B1*C1qg[idx]*gamma2qqbp[idx]*LQ2-B1*C1qg[idx]*gamma2qqbp[idx]*LQ*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+3.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF-3./2.*B1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+1./2.*A1*C1qg[idx]*gamma2qqbp[idx]*LQ3-1./2.*A1*C1qg[idx]*gamma2qqbp[idx]*LQ2*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+3./2.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF-3./4.*A1*C1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2;}
complex <double> muf::h4st_qbq_qg   (int idx) {return +2.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+2.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2-4.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
complex <double> muf::h4st_qbqp_qg  (int idx) {return +C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
complex <double> muf::h4st_qbqbp_qg (int idx) {return +C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
complex <double> muf::h4st_qpqp_qg  (int idx) {return +C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2-2.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
complex <double> muf::h4st_qpqbp_qg (int idx) {return +2.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+2.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2-4.*C1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
complex <double> muf::h4st_qbpqp_qg (int idx) {return +2.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+2.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2-4.*C1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3-C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF-3.*C1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2;}
