#include "muf.h"
#include "resint.h"
#include "pmom.h"
#include "mesq.h"
#include "settings.h"
#include "ccoeff.h"
#include "resconst.h"

using namespace pmom;
using namespace resconst;
using namespace ccoeff;

complex <double> muf::h4st_gg    (int idx ) {return + pow(gamma2qg[idx],2)*LF2+ pow(gamma2qg[idx],2)*LQ2- 2.*pow(gamma2qg[idx],2)*LQ*LF+ 2.*gamma1qg[idx]*gamma3qg[idx]*LF2+ 2.*gamma1qg[idx]*gamma3qg[idx]*LQ2- 4.*gamma1qg[idx]*gamma3qg[idx]*LQ*LF+ gamma1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LF3- gamma1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ3+ 5.*gamma1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ2*LF- 5.*gamma1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ*LF2+ 2.*pow(gamma1qg[idx],2)*gamma2qqbp[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2qqbp[idx]*LQ*LF2+ 2.*pow(gamma1qg[idx],2)*gamma2qqp[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2qqp[idx]*LQ*LF2 + 2.*pow(gamma1qg[idx],2)*gamma2qqb[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2qqb[idx]*LQ*LF2+ 2.*pow(gamma1qg[idx],2)*gamma2gg[idx]*LF3- 2.*pow(gamma1qg[idx],2)*gamma2gg[idx]*LQ3+ 4.*pow(gamma1qg[idx],2)*gamma2gg[idx]*LQ2*LF- 4.*pow(gamma1qg[idx],2)*gamma2gg[idx]*LQ*LF2+ 7./12.*pow(gamma1qg[idx],2)*pow(gamma1gg[idx],2)*LF4+ 7./12.*pow(gamma1qg[idx],2)*pow(gamma1gg[idx],2)*LQ4- 7./3.*pow(gamma1qg[idx],2)*pow(gamma1gg[idx],2)*LQ3*LF+ 7./2.*pow(gamma1qg[idx],2)*pow(gamma1gg[idx],2)*LQ2*LF2- 7./3.*pow(gamma1qg[idx],2)*pow(gamma1gg[idx],2)*LQ*LF3+ 2.*gamma2qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF- 2.*gamma2qq[idx]*pow(gamma1qg[idx],2)*LQ*LF2+ 3.*gamma1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LF3- 3.*gamma1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LQ3 + 7.*gamma1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LQ2*LF- 7.*gamma1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LQ*LF2+ 5./6.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LF4+ 5./6.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ4- 10./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ3*LF+ 5.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ2*LF2- 10./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ*LF3+ 7./12.*pow(gamma1qq[idx],2)*pow(gamma1qg[idx],2)*LF4+ 7./12.*pow(gamma1qq[idx],2)*pow(gamma1qg[idx],2)*LQ4- 7./3.*pow(gamma1qq[idx],2)*pow(gamma1qg[idx],2)*LQ3*LF+ 7./2.*pow(gamma1qq[idx],2)*pow(gamma1qg[idx],2)*LQ2*LF2- 7./3.*pow(gamma1qq[idx],2)*pow(gamma1qg[idx],2)*LQ*LF3+ 2.*EC3qg[idx]*gamma1qg[idx]*LF- 2.*EC3qg[idx]*gamma1qg[idx]*LQ+ 2.*EC2qg[idx]*gamma2qg[idx]*LF - 2.*EC2qg[idx]*gamma2qg[idx]*LQ+ 3.*EC2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+ 3.*EC2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2- 6.*EC2qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+ EC2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+ EC2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2- 2.*EC2qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+ 2.*EC1qg[idx]*gamma3qg[idx]*LF- 2.*EC1qg[idx]*gamma3qg[idx]*LQ+ 2.*EC1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LF2+ 2.*EC1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ2- 6.*EC1qg[idx]*gamma2qg[idx]*gamma1gg[idx]*LQ*LF- 2.*EC1qg[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF- 2.*EC1qg[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF- 2.*EC1qg[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF + 4.*EC1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LF2+ 4.*EC1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LQ2- 6.*EC1qg[idx]*gamma1qg[idx]*gamma2gg[idx]*LQ*LF+ 7./3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LF3- 7./3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ3+ 7.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ2*LF- 7.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gg[idx],2)*LQ*LF2- 2.*EC1qg[idx]*gamma2qq[idx]*gamma1qg[idx]*LQ*LF+ 2.*EC1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LF2+ 2.*EC1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LQ2- 2.*EC1qg[idx]*gamma1qq[idx]*gamma2qg[idx]*LQ*LF+ 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LF3- 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3+ 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF- 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF2 + 1./3.*EC1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LF3- 1./3.*EC1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ3+ EC1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ2*LF- EC1qg[idx]*pow(gamma1qq[idx],2)*gamma1qg[idx]*LQ*LF2+ 4.*EC1qg[idx]*EC2qg[idx]*gamma1gg[idx]*LF- 4.*EC1qg[idx]*EC2qg[idx]*gamma1gg[idx]*LQ+ 2.*pow(EC1qg[idx],2)*gamma2gg[idx]*LF- 2.*pow(EC1qg[idx],2)*gamma2gg[idx]*LQ+ 2.*pow(EC1qg[idx],2)*pow(gamma1gg[idx],2)*LF2+ 2.*pow(EC1qg[idx],2)*pow(gamma1gg[idx],2)*LQ2- 4.*pow(EC1qg[idx],2)*pow(gamma1gg[idx],2)*LQ*LF+ 2.*EC2qqbp[idx]*pow(gamma1qg[idx],2)*LF2+ 2.*EC2qqbp[idx]*pow(gamma1qg[idx],2)*LQ2- 4.*EC2qqbp[idx]*pow(gamma1qg[idx],2)*LQ*LF+ 2.*EC2qqbp[idx]*EC1qg[idx]*gamma1qg[idx]*LF - 2.*EC2qqbp[idx]*EC1qg[idx]*gamma1qg[idx]*LQ+ 2.*EC2qqp[idx]*pow(gamma1qg[idx],2)*LF2+ 2.*EC2qqp[idx]*pow(gamma1qg[idx],2)*LQ2- 4.*EC2qqp[idx]*pow(gamma1qg[idx],2)*LQ*LF+ 2.*EC2qqp[idx]*EC1qg[idx]*gamma1qg[idx]*LF- 2.*EC2qqp[idx]*EC1qg[idx]*gamma1qg[idx]*LQ+ 2.*EC2qqb[idx]*pow(gamma1qg[idx],2)*LF2+ 2.*EC2qqb[idx]*pow(gamma1qg[idx],2)*LQ2- 4.*EC2qqb[idx]*pow(gamma1qg[idx],2)*LQ*LF+ 2.*EC2qqb[idx]*EC1qg[idx]*gamma1qg[idx]*LF- 2.*EC2qqb[idx]*EC1qg[idx]*gamma1qg[idx]*LQ+ 2.*EC2qq[idx]*pow(gamma1qg[idx],2)*LF2+ 2.*EC2qq[idx]*pow(gamma1qg[idx],2)*LQ2- 4.*EC2qq[idx]*pow(gamma1qg[idx],2)*LQ*LF+ 2.*EC2qq[idx]*EC1qg[idx]*gamma1qg[idx]*LF - 2.*EC2qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ+ 4.*EC1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LF2+ 4.*EC1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LQ2- 8.*EC1qq[idx]*gamma1qg[idx]*gamma2qg[idx]*LQ*LF+ 2.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LF3- 2.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ3+ 6.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ2*LF- 6.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ*LF2+ 2.*EC1qq[idx]*gamma1qq[idx]*pow(gamma1qg[idx],2)*LF3- 2.*EC1qq[idx]*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ3+ 6.*EC1qq[idx]*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF- 6.*EC1qq[idx]*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ*LF2+ 2.*EC1qq[idx]*EC2qg[idx]*gamma1qg[idx]*LF- 2.*EC1qq[idx]*EC2qg[idx]*gamma1qg[idx]*LQ+ 2.*EC1qq[idx]*EC1qg[idx]*gamma2qg[idx]*LF - 2.*EC1qq[idx]*EC1qg[idx]*gamma2qg[idx]*LQ+ 3.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+ 3.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2- 6.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+ EC1qq[idx]*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+ EC1qq[idx]*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2- 2.*EC1qq[idx]*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+ pow(EC1qq[idx],2)*pow(gamma1qg[idx],2)*LF2+ pow(EC1qq[idx],2)*pow(gamma1qg[idx],2)*LQ2- 2.*pow(EC1qq[idx],2)*pow(gamma1qg[idx],2)*LQ*LF+ 2./3.*double(NF)*pow(gamma1qg[idx],3)*gamma1gq[idx]*LF4+ 2./3.*double(NF)*pow(gamma1qg[idx],3)*gamma1gq[idx]*LQ4- 8./3.*double(NF)*pow(gamma1qg[idx],3)*gamma1gq[idx]*LQ3*LF+ 4.*double(NF)*pow(gamma1qg[idx],3)*gamma1gq[idx]*LQ2*LF2- 8./3.*double(NF)*pow(gamma1qg[idx],3)*gamma1gq[idx]*LQ*LF3 + 8./3.*double(NF)*EC1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF3- 8./3.*double(NF)*EC1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3+ 8.*double(NF)*EC1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF- 8.*double(NF)*EC1qg[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF2+ 2.*double(NF)*pow(EC1qg[idx],2)*gamma1qg[idx]*gamma1gq[idx]*LF2+ 2.*double(NF)*pow(EC1qg[idx],2)*gamma1qg[idx]*gamma1gq[idx]*LQ2- 4.*double(NF)*pow(EC1qg[idx],2)*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ beta1*pow(gamma1qg[idx],2)*LF3+ beta1*pow(gamma1qg[idx],2)*LQ3- beta1*pow(gamma1qg[idx],2)*LQ2*LF- beta1*pow(gamma1qg[idx],2)*LQ*LF2+ beta1*EC1qg[idx]*gamma1qg[idx]*LF2- 3.*beta1*EC1qg[idx]*gamma1qg[idx]*LQ2+ 2.*beta1*EC1qg[idx]*gamma1qg[idx]*LQ*LF+ 3.*beta0*gamma1qg[idx]*gamma2qg[idx]*LF3 + 3.*beta0*gamma1qg[idx]*gamma2qg[idx]*LQ3- 3.*beta0*gamma1qg[idx]*gamma2qg[idx]*LQ2*LF- 3.*beta0*gamma1qg[idx]*gamma2qg[idx]*LQ*LF2+ 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gg[idx]*LF4- 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ4+ 3.*beta0*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ3*LF- 3.*beta0*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ*LF3+ 3./2.*beta0*gamma1qq[idx]*pow(gamma1qg[idx],2)*LF4- 3./2.*beta0*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ4+ 3.*beta0*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ3*LF- 3.*beta0*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ*LF3+ beta0*EC2qg[idx]*gamma1qg[idx]*LF2- 5.*beta0*EC2qg[idx]*gamma1qg[idx]*LQ2+ 4.*beta0*EC2qg[idx]*gamma1qg[idx]*LQ*LF+ 2.*beta0*EC1qg[idx]*gamma2qg[idx]*LF2 - 4.*beta0*EC1qg[idx]*gamma2qg[idx]*LQ2+ 2.*beta0*EC1qg[idx]*gamma2qg[idx]*LQ*LF+ 3.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LF3+ 6.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3- 9.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF+ beta0*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LF3+ 2.*beta0*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3- 3.*beta0*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF+ beta0*pow(EC1qg[idx],2)*gamma1gg[idx]*LF2- 5.*beta0*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ2+ 4.*beta0*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ*LF+ 2.*beta0*EC1qq[idx]*pow(gamma1qg[idx],2)*LF3+ 4.*beta0*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ3- 6.*beta0*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF+ beta0*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LF2 - 5.*beta0*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ2+ 4.*beta0*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ*LF+ 11./12.*pow(beta0,2)*pow(gamma1qg[idx],2)*LF4+ 11./12.*pow(beta0,2)*pow(gamma1qg[idx],2)*LQ4- 2./3.*pow(beta0,2)*pow(gamma1qg[idx],2)*LQ3*LF- 1./2.*pow(beta0,2)*pow(gamma1qg[idx],2)*LQ2*LF2- 2./3.*pow(beta0,2)*pow(gamma1qg[idx],2)*LQ*LF3+ 2./3.*pow(beta0,2)*EC1qg[idx]*gamma1qg[idx]*LF3- 11./3.*pow(beta0,2)*EC1qg[idx]*gamma1qg[idx]*LQ3+ 2.*pow(beta0,2)*EC1qg[idx]*gamma1qg[idx]*LQ2*LF+ pow(beta0,2)*EC1qg[idx]*gamma1qg[idx]*LQ*LF2- B2*pow(gamma1qg[idx],2)*LQ3+ 2.*B2*pow(gamma1qg[idx],2)*LQ2*LF- B2*pow(gamma1qg[idx],2)*LQ*LF2+ 2.*B2*EC1qg[idx]*gamma1qg[idx]*LQ2 - 2.*B2*EC1qg[idx]*gamma1qg[idx]*LQ*LF- 2.*B1*gamma1qg[idx]*gamma2qg[idx]*LQ3+ 4.*B1*gamma1qg[idx]*gamma2qg[idx]*LQ2*LF- 2.*B1*gamma1qg[idx]*gamma2qg[idx]*LQ*LF2+ B1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ4- 3.*B1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ3*LF+ 3.*B1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ2*LF2- B1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ*LF3+ B1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ4- 3.*B1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ3*LF+ 3.*B1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF2- B1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ*LF3+ 2.*B1*EC2qg[idx]*gamma1qg[idx]*LQ2- 2.*B1*EC2qg[idx]*gamma1qg[idx]*LQ*LF+ 2.*B1*EC1qg[idx]*gamma2qg[idx]*LQ2 - 2.*B1*EC1qg[idx]*gamma2qg[idx]*LQ*LF- 3.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3+ 6.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF- 3.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF2- B1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3+ 2.*B1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF- B1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF2+ 2.*B1*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ2- 2.*B1*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ*LF- 2.*B1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ3+ 4.*B1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF- 2.*B1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ*LF2+ 2.*B1*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ2- 2.*B1*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ*LF- 3./2.*B1*beta0*pow(gamma1qg[idx],2)*LQ4 + 2.*B1*beta0*pow(gamma1qg[idx],2)*LQ3*LF+ 1./2.*B1*beta0*pow(gamma1qg[idx],2)*LQ2*LF2- B1*beta0*pow(gamma1qg[idx],2)*LQ*LF3+ 4.*B1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ3- 3.*B1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ2*LF- B1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ*LF2+ 1./2.*pow(B1,2)*pow(gamma1qg[idx],2)*LQ4- pow(B1,2)*pow(gamma1qg[idx],2)*LQ3*LF+ 1./2.*pow(B1,2)*pow(gamma1qg[idx],2)*LQ2*LF2- pow(B1,2)*EC1qg[idx]*gamma1qg[idx]*LQ3+ pow(B1,2)*EC1qg[idx]*gamma1qg[idx]*LQ2*LF- 1./2.*A2*pow(gamma1qg[idx],2)*LQ4+ A2*pow(gamma1qg[idx],2)*LQ3*LF- 1./2.*A2*pow(gamma1qg[idx],2)*LQ2*LF2+ A2*EC1qg[idx]*gamma1qg[idx]*LQ3 - A2*EC1qg[idx]*gamma1qg[idx]*LQ2*LF- A1*gamma1qg[idx]*gamma2qg[idx]*LQ4+ 2.*A1*gamma1qg[idx]*gamma2qg[idx]*LQ3*LF- A1*gamma1qg[idx]*gamma2qg[idx]*LQ2*LF2+ 1./2.*A1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ5- 3./2.*A1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ4*LF+ 3./2.*A1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ3*LF2- 1./2.*A1*pow(gamma1qg[idx],2)*gamma1gg[idx]*LQ2*LF3+ 1./2.*A1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ5- 3./2.*A1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ4*LF+ 3./2.*A1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ3*LF2- 1./2.*A1*gamma1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF3+ A1*EC2qg[idx]*gamma1qg[idx]*LQ3- A1*EC2qg[idx]*gamma1qg[idx]*LQ2*LF+ A1*EC1qg[idx]*gamma2qg[idx]*LQ3 - A1*EC1qg[idx]*gamma2qg[idx]*LQ2*LF- 3./2.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ4+ 3.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ3*LF- 3./2.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2*LF2- 1./2.*A1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ4+ A1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ3*LF- 1./2.*A1*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2*LF2+ A1*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ3- A1*pow(EC1qg[idx],2)*gamma1gg[idx]*LQ2*LF- A1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ4+ 2.*A1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ3*LF- A1*EC1qq[idx]*pow(gamma1qg[idx],2)*LQ2*LF2+ A1*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ3- A1*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*LQ2*LF- 5./6.*A1*beta0*pow(gamma1qg[idx],2)*LQ5 + 7./6.*A1*beta0*pow(gamma1qg[idx],2)*LQ4*LF+ 1./6.*A1*beta0*pow(gamma1qg[idx],2)*LQ3*LF2- 1./2.*A1*beta0*pow(gamma1qg[idx],2)*LQ2*LF3+ 13./6.*A1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ4- 5./3.*A1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ3*LF- 1./2.*A1*beta0*EC1qg[idx]*gamma1qg[idx]*LQ2*LF2+ 1./2.*A1*B1*pow(gamma1qg[idx],2)*LQ5- A1*B1*pow(gamma1qg[idx],2)*LQ4*LF+ 1./2.*A1*B1*pow(gamma1qg[idx],2)*LQ3*LF2- A1*B1*EC1qg[idx]*gamma1qg[idx]*LQ4+ A1*B1*EC1qg[idx]*gamma1qg[idx]*LQ3*LF+ 1./8.*pow(A1,2)*pow(gamma1qg[idx],2)*LQ6- 1./4.*pow(A1,2)*pow(gamma1qg[idx],2)*LQ5*LF+ 1./8.*pow(A1,2)*pow(gamma1qg[idx],2)*LQ4*LF2- 1./4.*pow(A1,2)*EC1qg[idx]*gamma1qg[idx]*LQ5 + 1./4.*pow(A1,2)*EC1qg[idx]*gamma1qg[idx]*LQ4*LF ;}
complex <double> muf::h4st_qbg   (int idx ) {return + gamma2qg[idx]*gamma2qqb[idx]*LF2+ gamma2qg[idx]*gamma2qqb[idx]*LQ2- 2.*gamma2qg[idx]*gamma2qqb[idx]*LQ*LF+ gamma1qg[idx]*gamma3qqb[idx]*LF2+ gamma1qg[idx]*gamma3qqb[idx]*LQ2- 2.*gamma1qg[idx]*gamma3qqb[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF3- 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ3+ 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2*LF- 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF2 + pow(gamma1qg[idx],2)*gamma2gq[idx]*LF3- pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ3+ 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ*LF2+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF4+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ4- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF+ 5./2.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF3+ 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LF3- 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ3+ 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ2*LF- 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF2+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4 - 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]* LQ3*LF+ 7./2.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ EC2qg[idx]*gamma2qqb[idx]*LF- EC2qg[idx]*gamma2qqb[idx]*LQ+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qg[idx]*gamma3qqb[idx]*LF- EC1qg[idx]*gamma3qqb[idx]*LQ+ EC1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LF2+ EC1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ2- 2.*EC1qg[idx]*gamma1gg[idx]*gamma2qqb[idx]*LQ*LF+ EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2 + EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2- 3.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+ 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3- 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+ 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF- 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2- EC1qg[idx]*gamma1qq[idx]*gamma2qqb[idx]*LQ*LF+ 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3- 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LF - 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LQ+ pow(EC1qg[idx],2)*gamma2gq[idx]*LF- pow(EC1qg[idx],2)*gamma2gq[idx]*LQ+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF2+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2- 3.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LF2+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ2- pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+ EC3qqb[idx]*gamma1qg[idx]*LF- EC3qqb[idx]*gamma1qg[idx]*LQ+ EC2qqb[idx]*gamma2qg[idx]*LF- EC2qqb[idx]*gamma2qg[idx]*LQ+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2 - EC2qqb[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*EC2qqb[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+ 1./2.*EC2qqb[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2- EC2qqb[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+ EC2qqb[idx]*EC1qg[idx]*gamma1gg[idx]*LF- EC2qqb[idx]*EC1qg[idx]*gamma1gg[idx]*LQ+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LF2+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ2- 4.*EC1qq[idx]*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF+ EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF3- EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3+ 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF- 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF2+ EC1qq[idx]*EC1qg[idx]*gamma2qqb[idx]*LF- EC1qq[idx]*EC1qg[idx]*gamma2qqb[idx]*LQ + 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qq[idx]*EC2qqb[idx]*gamma1qg[idx]*LF- EC1qq[idx]*EC2qqb[idx]*gamma1qg[idx]*LQ+ 3./2.*beta0*gamma1qg[idx]*gamma2qqb[idx]*LF3+ 3./2.*beta0*gamma1qg[idx]*gamma2qqb[idx]*LQ3- 3./2.*beta0*gamma1qg[idx]*gamma2qqb[idx]*LQ2*LF- 3./2.*beta0*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF2+ 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4- 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4+ 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF- 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ beta0*EC1qg[idx]*gamma2qqb[idx]*LF2- 2.*beta0*EC1qg[idx]*gamma2qqb[idx]*LQ2 + beta0*EC1qg[idx]*gamma2qqb[idx]*LQ*LF+ 3./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+ 3.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3- 9./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+ 1./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LF2- 5./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2+ 2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ 1./2.*beta0*EC2qqb[idx]*gamma1qg[idx]*LF2- 5./2.*beta0*EC2qqb[idx]*gamma1qg[idx]*LQ2+ 2.*beta0*EC2qqb[idx]*gamma1qg[idx]*LQ*LF- B1*gamma1qg[idx]*gamma2qqb[idx]*LQ3+ 2.*B1*gamma1qg[idx]*gamma2qqb[idx]*LQ2*LF- B1*gamma1qg[idx]*gamma2qqb[idx]*LQ*LF2+ 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4- 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF + 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ B1*EC1qg[idx]*gamma2qqb[idx]*LQ2- B1*EC1qg[idx]*gamma2qqb[idx]*LQ*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 3.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2- B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ B1*EC2qqb[idx]*gamma1qg[idx]*LQ2- B1*EC2qqb[idx]*gamma1qg[idx]*LQ*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqb[idx]*LQ4+ A1*gamma1qg[idx]*gamma2qqb[idx]*LQ3*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqb[idx]*LQ2*LF2+ 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ5 - 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4*LF+ 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF2- 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF3+ 1./2.*A1*EC1qg[idx]*gamma2qqb[idx]*LQ3- 1./2.*A1*EC1qg[idx]*gamma2qqb[idx]*LQ2*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+ 3./2.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2+ 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ3- 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2*LF+ 1./2.*A1*EC2qqb[idx]*gamma1qg[idx]*LQ3- 1./2.*A1*EC2qqb[idx]*gamma1qg[idx]*LQ2*LF ;}
complex <double> muf::h4st_qpg   (int idx ) {return + gamma2qg[idx]*gamma2qqp[idx]*LF2+ gamma2qg[idx]*gamma2qqp[idx]*LQ2- 2.*gamma2qg[idx]*gamma2qqp[idx]*LQ*LF+ gamma1qg[idx]*gamma3qqp[idx]*LF2+ gamma1qg[idx]*gamma3qqp[idx]*LQ2- 2.*gamma1qg[idx]*gamma3qqp[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF3- 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ3+ 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2*LF- 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF2 + pow(gamma1qg[idx],2)*gamma2gq[idx]*LF3- pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ3+ 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ*LF2+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF4+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ4- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF+ 5./2.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF3+ 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LF3- 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ3+ 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ2*LF- 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF2+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4 - 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]* LQ3*LF+ 7./2.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ EC2qg[idx]*gamma2qqp[idx]*LF- EC2qg[idx]*gamma2qqp[idx]*LQ+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qg[idx]*gamma3qqp[idx]*LF- EC1qg[idx]*gamma3qqp[idx]*LQ+ EC1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LF2+ EC1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gg[idx]*gamma2qqp[idx]*LQ*LF+ EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2 + EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2- 3.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+ 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3- 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+ 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF- 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2- EC1qg[idx]*gamma1qq[idx]*gamma2qqp[idx]*LQ*LF+ 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3- 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LF - 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LQ+ pow(EC1qg[idx],2)*gamma2gq[idx]*LF- pow(EC1qg[idx],2)*gamma2gq[idx]*LQ+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF2+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2- 3.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LF2+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ2- pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+ EC3qqp[idx]*gamma1qg[idx]*LF- EC3qqp[idx]*gamma1qg[idx]*LQ+ EC2qqp[idx]*gamma2qg[idx]*LF- EC2qqp[idx]*gamma2qg[idx]*LQ+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2 - EC2qqp[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*EC2qqp[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+ 1./2.*EC2qqp[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2- EC2qqp[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+ EC2qqp[idx]*EC1qg[idx]*gamma1gg[idx]*LF- EC2qqp[idx]*EC1qg[idx]*gamma1gg[idx]*LQ+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LF2+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ2- 4.*EC1qq[idx]*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF+ EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF3- EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3+ 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF- 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF2+ EC1qq[idx]*EC1qg[idx]*gamma2qqp[idx]*LF- EC1qq[idx]*EC1qg[idx]*gamma2qqp[idx]*LQ + 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qq[idx]*EC2qqp[idx]*gamma1qg[idx]*LF- EC1qq[idx]*EC2qqp[idx]*gamma1qg[idx]*LQ+ 3./2.*beta0*gamma1qg[idx]*gamma2qqp[idx]*LF3+ 3./2.*beta0*gamma1qg[idx]*gamma2qqp[idx]*LQ3- 3./2.*beta0*gamma1qg[idx]*gamma2qqp[idx]*LQ2*LF- 3./2.*beta0*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF2+ 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4- 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4+ 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF- 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ beta0*EC1qg[idx]*gamma2qqp[idx]*LF2- 2.*beta0*EC1qg[idx]*gamma2qqp[idx]*LQ2 + beta0*EC1qg[idx]*gamma2qqp[idx]*LQ*LF+ 3./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+ 3.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3- 9./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+ 1./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LF2- 5./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2+ 2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ 1./2.*beta0*EC2qqp[idx]*gamma1qg[idx]*LF2- 5./2.*beta0*EC2qqp[idx]*gamma1qg[idx]*LQ2+ 2.*beta0*EC2qqp[idx]*gamma1qg[idx]*LQ*LF- B1*gamma1qg[idx]*gamma2qqp[idx]*LQ3+ 2.*B1*gamma1qg[idx]*gamma2qqp[idx]*LQ2*LF- B1*gamma1qg[idx]*gamma2qqp[idx]*LQ*LF2+ 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4- 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF + 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ B1*EC1qg[idx]*gamma2qqp[idx]*LQ2- B1*EC1qg[idx]*gamma2qqp[idx]*LQ*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 3.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2- B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ B1*EC2qqp[idx]*gamma1qg[idx]*LQ2- B1*EC2qqp[idx]*gamma1qg[idx]*LQ*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqp[idx]*LQ4+ A1*gamma1qg[idx]*gamma2qqp[idx]*LQ3*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqp[idx]*LQ2*LF2+ 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ5 - 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4*LF+ 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF2- 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF3+ 1./2.*A1*EC1qg[idx]*gamma2qqp[idx]*LQ3- 1./2.*A1*EC1qg[idx]*gamma2qqp[idx]*LQ2*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+ 3./2.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2+ 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ3- 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2*LF+ 1./2.*A1*EC2qqp[idx]*gamma1qg[idx]*LQ3- 1./2.*A1*EC2qqp[idx]*gamma1qg[idx]*LQ2*LF ;}
complex <double> muf::h4st_qbpg  (int idx ) {return + gamma2qg[idx]*gamma2qqbp[idx]*LF2+ gamma2qg[idx]*gamma2qqbp[idx]*LQ2- 2.*gamma2qg[idx]*gamma2qqbp[idx]*LQ*LF+ gamma1qg[idx]*gamma3qqbp[idx]*LF2+ gamma1qg[idx]*gamma3qqbp[idx]*LQ2- 2.*gamma1qg[idx]*gamma3qqbp[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF3- 1./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ3+ 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2*LF- 5./2.*gamma1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF2 + pow(gamma1qg[idx],2)*gamma2gq[idx]*LF3- pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ3+ 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ2*LF- 2.*pow(gamma1qg[idx],2)*gamma2gq[idx]*LQ*LF2+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF4+ 5./12.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ4- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ3*LF+ 5./2.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF2- 5./3.*pow(gamma1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF3+ 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LF3- 1./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ3+ 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ2*LF- 5./2.*gamma1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF2+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4+ 7./12.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4 - 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]* LQ3*LF+ 7./2.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 7./3.*gamma1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ EC2qg[idx]*gamma2qqbp[idx]*LF- EC2qg[idx]*gamma2qqbp[idx]*LQ+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC2qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qg[idx]*gamma3qqbp[idx]*LF- EC1qg[idx]*gamma3qqbp[idx]*LQ+ EC1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LF2+ EC1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gg[idx]*gamma2qqbp[idx]*LQ*LF+ EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LF2 + EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qg[idx]*gamma2qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LF2+ 2.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ2- 3.*EC1qg[idx]*gamma1qg[idx]*gamma2gq[idx]*LQ*LF+ 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LF3- 5./3.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ3+ 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ2*LF- 5.*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*gamma1gg[idx]*LQ*LF2- EC1qg[idx]*gamma1qq[idx]*gamma2qqbp[idx]*LQ*LF+ 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3- 4./3.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 4.*EC1qg[idx]*gamma1qq[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LF - 2.*EC1qg[idx]*EC2qg[idx]*gamma1gq[idx]*LQ+ pow(EC1qg[idx],2)*gamma2gq[idx]*LF- pow(EC1qg[idx],2)*gamma2gq[idx]*LQ+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LF2+ 3./2.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ2- 3.*pow(EC1qg[idx],2)*gamma1gq[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LF2+ 1./2.*pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ2- pow(EC1qg[idx],2)*gamma1qq[idx]*gamma1gq[idx]*LQ*LF+ EC3qqbp[idx]*gamma1qg[idx]*LF- EC3qqbp[idx]*gamma1qg[idx]*LQ+ EC2qqbp[idx]*gamma2qg[idx]*LF- EC2qqbp[idx]*gamma2qg[idx]*LQ+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gg[idx]*LF2+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ2 - EC2qqbp[idx]*gamma1qg[idx]*gamma1gg[idx]*LQ*LF+ 1./2.*EC2qqbp[idx]*gamma1qq[idx]*gamma1qg[idx]*LF2+ 1./2.*EC2qqbp[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ2- EC2qqbp[idx]*gamma1qq[idx]*gamma1qg[idx]*LQ*LF+ EC2qqbp[idx]*EC1qg[idx]*gamma1gg[idx]*LF- EC2qqbp[idx]*EC1qg[idx]*gamma1gg[idx]*LQ+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LF2+ 2.*EC1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ2- 4.*EC1qq[idx]*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF+ EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF3- EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3+ 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF- 3.*EC1qq[idx]*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF2+ EC1qq[idx]*EC1qg[idx]*gamma2qqbp[idx]*LF- EC1qq[idx]*EC1qg[idx]*gamma2qqbp[idx]*LQ + 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 3./2.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 3.*EC1qq[idx]*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC1qq[idx]*EC2qqbp[idx]*gamma1qg[idx]*LF- EC1qq[idx]*EC2qqbp[idx]*gamma1qg[idx]*LQ+ 3./2.*beta0*gamma1qg[idx]*gamma2qqbp[idx]*LF3+ 3./2.*beta0*gamma1qg[idx]*gamma2qqbp[idx]*LQ3- 3./2.*beta0*gamma1qg[idx]*gamma2qqbp[idx]*LQ2*LF- 3./2.*beta0*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF2+ 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LF4- 3./4.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4+ 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF- 3./2.*beta0*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ beta0*EC1qg[idx]*gamma2qqbp[idx]*LF2- 2.*beta0*EC1qg[idx]*gamma2qqbp[idx]*LQ2 + beta0*EC1qg[idx]*gamma2qqbp[idx]*LQ*LF+ 3./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LF3+ 3.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3- 9./2.*beta0*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF+ 1./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LF2- 5./2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2+ 2.*beta0*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ 1./2.*beta0*EC2qqbp[idx]*gamma1qg[idx]*LF2- 5./2.*beta0*EC2qqbp[idx]*gamma1qg[idx]*LQ2+ 2.*beta0*EC2qqbp[idx]*gamma1qg[idx]*LQ*LF- B1*gamma1qg[idx]*gamma2qqbp[idx]*LQ3+ 2.*B1*gamma1qg[idx]*gamma2qqbp[idx]*LQ2*LF- B1*gamma1qg[idx]*gamma2qqbp[idx]*LQ*LF2+ 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4- 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF + 3./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF2- 1./2.*B1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ*LF3+ B1*EC1qg[idx]*gamma2qqbp[idx]*LQ2- B1*EC1qg[idx]*gamma2qqbp[idx]*LQ*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3+ 3.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF- 3./2.*B1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF2+ B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2- B1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ*LF+ B1*EC2qqbp[idx]*gamma1qg[idx]*LQ2- B1*EC2qqbp[idx]*gamma1qg[idx]*LQ*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqbp[idx]*LQ4+ A1*gamma1qg[idx]*gamma2qqbp[idx]*LQ3*LF- 1./2.*A1*gamma1qg[idx]*gamma2qqbp[idx]*LQ2*LF2+ 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ5 - 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ4*LF+ 3./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ3*LF2- 1./4.*A1*pow(gamma1qg[idx],2)*gamma1gq[idx]*LQ2*LF3+ 1./2.*A1*EC1qg[idx]*gamma2qqbp[idx]*LQ3- 1./2.*A1*EC1qg[idx]*gamma2qqbp[idx]*LQ2*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ4+ 3./2.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ3*LF- 3./4.*A1*EC1qg[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2*LF2+ 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ3- 1./2.*A1*pow(EC1qg[idx],2)*gamma1gq[idx]*LQ2*LF+ 1./2.*A1*EC2qqbp[idx]*gamma1qg[idx]*LQ3- 1./2.*A1*EC2qqbp[idx]*gamma1qg[idx]*LQ2*LF ;}
